package utils.numbers.hidden {
	
	/**
	 * Number, который нельзя найти сканированием адресов памяти
	 * 
	 * @author gloomyBrain
	 */
	public final class HiddenNumber {
		
		private var _delta:int;
		private var _storedValue:Number;
		
		/**
		 * @param	value	Значение, которое необходимо спрятать
		 */
		public function HiddenNumber(value:Number = 0) {
			
			this.value = value;
			
		}
		
		/**
		 * Спрятанное числовое значение
		 */
		public function get value():Number {
			
			return (_storedValue - _delta);
			
		}
		
		/**
		 * @private
		 */
		public function set value(value:Number):void {
			
			if (value > 0) {
				_delta = int(Math.random() * int.MIN_VALUE);
			}else {
				_delta = int(Math.random() * int.MAX_VALUE);
			}
			
			_storedValue = value + _delta;
			
		}
		
	}

}